CPSSEG	segment 'ANTICPS'
assume	cs:CPSSEG

public	_RESETS

old8	label	dword
old8o	dw	?
old8s	dw	?
old2F	label	dword
old2Fo	dw	?
old2Fs	dw	?
count	db	0
ticks	db	0
cps	dw	0
row	db	13
col	db	53
CPSLIM	dw	80

new2F	proc	far
	cmp	ax,0DAFDh
	jne	Quit2F
	mov	ax,0FFDAh
	mov	bx,cs
    mov cx,offset CPSLIM
	iret
Quit2F:
	jmp	dword ptr cs:[old2F]
new2F	endp

new8	proc	far
	inc	byte ptr cs:[ticks]
	cmp	byte ptr cs:[ticks],36
	jae	check
	jmp	dword ptr cs:old8
check:
	mov	byte ptr cs:[ticks],0
	push	es ax bx cx dx
	mov	ax,0B800h
	mov	es,ax
	mov	al,byte ptr cs:[row]
	mov	cl,160
	mul	cl
	xor	cx,cx
	mov	cl,byte ptr cs:[col]
	shl	cx,1
	add	ax,cx
	mov	bx,ax
	cmp	byte ptr es:[bx],'C'
	jne	NoFD
	add	bx,2
	cmp	byte ptr es:[bx],'P'
	jne	NoFD
	add	bx,2
	cmp	byte ptr es:[bx],'S'
	jne	NoFD
	add	bx,8
	mov	cx,10
	mov	word ptr cs:[cps],0
Calculate:
	mov	al,byte ptr es:[bx]
	inc	bx
	inc	bx
	cmp	al,' '
	je	nextStep
	mov	ah,0
	sub	al,'0'
	push	cx
	push	ax
	mov	ax,word ptr cs:[cps]
	mov	cx,10
	mul	cx
	pop	cx
	add	ax,cx
	mov	word ptr cs:[cps],ax
	pop	cx
NextStep:
	loop	Calculate
	mov	ax,word ptr cs:[cps]
	cmp	ax,0
	je	NoFD
	cmp	ax,word ptr cs:CPSLIM
	jae	NoFD
	inc	byte ptr cs:[count]
	cmp	byte ptr cs:[count],5
	jae	SetKBD
Quit:
	pop	dx cx bx ax es
	jmp	dword ptr cs:[old8]
NoFD:
	mov	byte ptr cs:[count],0
	jmp	Quit	
SetKBD:
	mov	ah,5
	mov	cx,02D00h
	int	16h
	jmp	NoFD
new8	endp

_RESETS	proc	far
        mov     dx,offset new8
        mov     ax, offset new2F
        ret
_RESETS endp

CPSSEG	ends
end	
